//==========================================================================================================================================================================================================
// HEADER      HEADER      HEADER      HEADER      HEADER      HEADER      HEADER      HEADER      HEADER      HEADER      HEADER      HEADER      HEADER      HEADER      HEADER      HEADER      HEADER
//==========================================================================================================================================================================================================
#include <d2d1.h>

void GUISetup();
void GUIUpdate();
void WindowCreate(Int32, Int32);
//==========================================================================================================================================================================================================
// END_HEADER      END_HEADER      END_HEADER      END_HEADER      END_HEADER      END_HEADER      END_HEADER      END_HEADER      END_HEADER      END_HEADER      END_HEADER      END_HEADER
//==========================================================================================================================================================================================================

//==========================================================================================================================================================================================================
// DATA      DATA      DATA      DATA      DATA      DATA      DATA      DATA      DATA      DATA      DATA      DATA      DATA      DATA      DATA      DATA      DATA      DATA      DATA      DATA
//==========================================================================================================================================================================================================
ID2D1SolidColorBrush *pBrush;
ID2D1Factory         *GraphicsFactory;
ID2D1DCRenderTarget  *DCRenderTarget;
ID2D1Bitmap          *Bitmap;
//==========================================================================================================================================================================================================
// END_DATA      END_DATA      END_DATA      END_DATA      END_DATA      END_DATA      END_DATA      END_DATA      END_DATA      END_DATA      END_DATA      END_DATA      END_DATA      END_DATA
//==========================================================================================================================================================================================================

//==========================================================================================================================================================================================================
// CODE      CODE      CODE      CODE      CODE      CODE      CODE      CODE      CODE      CODE      CODE      CODE      CODE      CODE      CODE      CODE      CODE      CODE      CODE      CODE
//==========================================================================================================================================================================================================
void    GUIEntry()
{
    GUISetup();
    GUIUpdate();
}

void    GUISetup()
{

}

void    GUIUpdate()
{

}
//==========================================================================================================================================================================================================
// END_CODE      END_CODE      END_CODE      END_CODE      END_CODE      END_CODE      END_CODE      END_CODE      END_CODE      END_CODE      END_CODE      END_CODE      END_CODE      END_CODE
//==========================================================================================================================================================================================================

//==========================================================================================================================================================================================================
// FUNCTION      FUNCTION      FUNCTION      FUNCTION      FUNCTION      FUNCTION      FUNCTION      FUNCTION      FUNCTION      FUNCTION      FUNCTION      FUNCTION      FUNCTION      FUNCTION
//==========================================================================================================================================================================================================
void    UpdateScreen()
{
    for (Int32 Index = 0; Index < SCREEN_WIDTH * SCREEN_HEIGHT; Index++)
    {
        Screen[Index] = Monoscope[Index];
    }

    InvalidateRect(WindowHandle, NULL, FALSE);
    //RedrawWindow(WindowHandle, NULL, NULL, RDW_INVALIDATE);
}
void    UpdateSpace3D(Particle* PtrSpace3D[])
{
    //#pragma omp parallel for
    //for (int X = 0; X < SpaceDim; X++)
    //{
    //    for (int Y = 0; Y < SpaceDim; Y++)
    //    {
    //        for (int Z = 0; Z < SpaceDim; Z++)
    //        {
    //            Int32 Index = X + SpaceDim * (Y + SpaceDim * Z);

    //            Space3D[Index].ID    = (*PtrSpace3D)[Index].ID;
    //            Space3D[Index].Color = (*PtrSpace3D)[Index].Color;
    //        }
    //    }
    //}
}

void    EnableDirectX()
{
    RECT        rc;
    PAINTSTRUCT ps;

    BeginPaint(WindowHandle, &ps);
    {
        GetClientRect(WindowHandle, &rc);
        D2D1_PIXEL_FORMAT             PixelFormat = D2D1::PixelFormat(DXGI_FORMAT_B8G8R8A8_UNORM, D2D1_ALPHA_MODE_IGNORE);
        D2D1_BITMAP_PROPERTIES        BmpInfo     = D2D1::BitmapProperties(PixelFormat);
        D2D1_RENDER_TARGET_PROPERTIES RenderInfo  = D2D1::RenderTargetProperties();
        RenderInfo.pixelFormat                    = PixelFormat;

        D2D1CreateFactory(D2D1_FACTORY_TYPE_SINGLE_THREADED, &GraphicsFactory);
        GraphicsFactory->CreateDCRenderTarget(&RenderInfo, &DCRenderTarget);

        DCRenderTarget->CreateBitmap(D2D1::SizeU(SCREEN_WIDTH, SCREEN_HEIGHT), NULL, NULL, BmpInfo, &Bitmap);
        DCRenderTarget->GetDpi(&BmpInfo.dpiX, &BmpInfo.dpiY);
        DCRenderTarget->BindDC(ps.hdc, &rc);
    }
    EndPaint(WindowHandle, &ps);
}

LRESULT CALLBACK WindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    Sleep(1);

    auto OnPaint = [&]
    {
        RECT        rc;
        PAINTSTRUCT ps;

        BeginPaint(WindowHandle, &ps);
        {
            GetClientRect(WindowHandle, &rc);

            //copy pixel buffer to bitmap
            D2D1_RECT_F RectF = D2D1::RectF(0, 0, (Single)SCREEN_WIDTH, (Single)SCREEN_HEIGHT);
            D2D1_RECT_U RectU = D2D1::RectU(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
            Bitmap->CopyFromMemory(&RectU, Screen.data(), SCREEN_WIDTH * 4);

            // Render bitmap to screen
            DCRenderTarget->BeginDraw();
            DCRenderTarget->DrawBitmap(Bitmap, RectF);
            DCRenderTarget->EndDraw();
            DCRenderTarget->BindDC(ps.hdc, &rc);

        }
        EndPaint(WindowHandle, &ps);
    };

    switch (uMsg)
    {
        case WM_KEYDOWN:
        {
            switch (wParam)
            {
                case VK_ESCAPE:
                {
                    DestroyWindow(hwnd);
                    PostQuitMessage(0);

                    // Free GPU memory
                    cudaFree(deviceInputData);
                    cudaFree(deviceOutputData);
                }
                break;
            }
        }
        break;

        case WM_PAINT:
        {
            OnPaint();
        }
        break;
    }

    return (DefWindowProc(hwnd, uMsg, wParam, lParam));
}
void    WindowCreate(Int32 SCREEN_WIDTH, Int32 SCREEN_HEIGHT)
{
    LPCSTR  WindowName = "Circle Window";
    LPCSTR  ClassName  = "Circle Window Class";

    WNDCLASS WindowStruct = { 0 };
    {
        WindowStruct.style         = CS_HREDRAW | CS_VREDRAW;
        WindowStruct.lpfnWndProc   = WindowProc;
        WindowStruct.hInstance     = GetModuleHandle(NULL);
        WindowStruct.lpszClassName = ClassName;
    }
    RegisterClass(&WindowStruct);

    WindowHandle = CreateWindow(ClassName, WindowName, WS_OVERLAPPEDWINDOW,
                                CW_USEDEFAULT, CW_USEDEFAULT, SCREEN_WIDTH, SCREEN_HEIGHT,
                                NULL, NULL, GetModuleHandle(NULL), NULL);

    ShowWindow(WindowHandle, 1);
    EnableDirectX();
}
//==========================================================================================================================================================================================================
// END_FUNCTION      END_FUNCTION      END_FUNCTION      END_FUNCTION      END_FUNCTION      END_FUNCTION      END_FUNCTION      END_FUNCTION      END_FUNCTION      END_FUNCTION      END_FUNCTION
//==========================================================================================================================================================================================================